/*
 *  Copyright (C) 2004 Link Dupont <link@subpop.net>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <tag_c.h>
#include <stdio.h>
#include <stdlib.h>

#include "lindele.h"

void
clear_tags (FileTag *f)
{
	f->artist = "";
	f->title = "";
	f->album = "";
	f->year = 0;
	f->track = 0;
	f->genre = "";
	f->comment = "";
}

void
init_filetag (FileTag * ft)
{
	ft->title = "";
	ft->artist = "";
	ft->album = "";
	ft->year = 0;
	ft->genre = "";
	ft->track = 0;
	ft->comment = "";
	ft->filepath = "";
}

gboolean
read_tag (FileTag *f, gchar * filepath)
{
	TagLib_File *file;
	TagLib_Tag *tag;

	if (file = taglib_file_new ((char *) filepath))
	{
    	tag = taglib_file_tag (file);
    	f->title = (gchar *) taglib_tag_title (tag);
    	f->artist = (gchar *) taglib_tag_artist (tag);
    	f->album = (gchar *) taglib_tag_album (tag);
    	f->year = (double) taglib_tag_year (tag);
    	f->genre = (gchar *) taglib_tag_genre (tag);
    	f->track = (double) taglib_tag_track (tag);
    	f->comment = (gchar *) taglib_tag_comment (tag);
    	f->filepath = filepath;
    	taglib_file_free (file);
    	return TRUE;
	}
	else
	   return NULL;
}
